################################
The :mod:`gramps.gen.lib` Module
################################

.. automodule:: gramps.gen.lib

*****************************
Base objects
*****************************

BaseObject
====================================
.. automodule:: gramps.gen.lib.baseobj
.. autoclass:: gramps.gen.lib.baseobj.BaseObject
   :members:
   :undoc-members:
   :show-inheritance:

AddressBase
====================================
.. automodule:: gramps.gen.lib.addressbase
.. autoclass:: AddressBase
   :members:
   :undoc-members:
   :show-inheritance:

AttributeRootBase
====================================
.. automodule:: gramps.gen.lib.attrbase
.. autoclass:: AttributeRootBase
   :members:
   :undoc-members:
   :show-inheritance:

AttributeBase
====================================
.. autoclass:: AttributeBase
   :members:
   :undoc-members:
   :show-inheritance:

SrcAttributeBase
====================================
.. autoclass:: SrcAttributeBase
   :members:
   :undoc-members:
   :show-inheritance:

CitationBase
====================================
.. automodule:: gramps.gen.lib.citationbase
.. autoclass:: CitationBase
   :members:
   :undoc-members:
   :show-inheritance:

IndirectCitationBase
====================================
.. autoclass:: IndirectCitationBase
   :members:
   :undoc-members:
   :show-inheritance:

DateBase
====================================
.. automodule:: gramps.gen.lib.datebase
.. autoclass:: DateBase
   :members:
   :undoc-members:
   :show-inheritance:

LdsOrdBase
====================================
.. automodule:: gramps.gen.lib.ldsordbase
.. autoclass:: LdsOrdBase
   :members:
   :undoc-members:
   :show-inheritance:

LocationBase
====================================
.. automodule:: gramps.gen.lib.locationbase
.. autoclass:: LocationBase
   :members:
   :undoc-members:
   :show-inheritance:

MediaBase
====================================
.. automodule:: gramps.gen.lib.mediabase
.. autoclass:: MediaBase
   :members:
   :undoc-members:
   :show-inheritance:

NoteBase
====================================
.. automodule:: gramps.gen.lib.notebase
.. autoclass:: NoteBase
   :members:
   :undoc-members:
   :show-inheritance:

PlaceBase
====================================
.. automodule:: gramps.gen.lib.placebase
.. autoclass:: PlaceBase
   :members:
   :undoc-members:
   :show-inheritance:

PrivacyBase
====================================
.. automodule:: gramps.gen.lib.privacybase
.. autoclass:: PrivacyBase
   :members:
   :undoc-members:
   :show-inheritance:

RefBase
====================================
.. automodule:: gramps.gen.lib.refbase
.. autoclass:: RefBase
   :members:
   :undoc-members:
   :show-inheritance:

SurnameBase
====================================
.. automodule:: gramps.gen.lib.surnamebase
.. autoclass:: SurnameBase
   :members:
   :undoc-members:
   :show-inheritance:

TagBase
====================================
.. automodule:: gramps.gen.lib.tagbase
.. autoclass:: TagBase
   :members:
   :undoc-members:
   :show-inheritance:

UrlBase
====================================
.. automodule:: gramps.gen.lib.urlbase
.. autoclass:: UrlBase
   :members:
   :undoc-members:
   :show-inheritance:

*****************************
Primary objects
*****************************

BasicPrimaryObject
====================================
.. automodule:: gramps.gen.lib.primaryobj
.. autoclass:: BasicPrimaryObject
   :members:
   :undoc-members:
   :show-inheritance:

PrimaryObject
====================================
.. autoclass:: PrimaryObject
   :members:
   :undoc-members:
   :show-inheritance:

Person
====================================
.. automodule:: gramps.gen.lib.person
.. autoclass:: Person
   :members:
   :undoc-members:
   :show-inheritance:

Family
====================================
.. automodule:: gramps.gen.lib.family
.. autoclass:: Family
   :members:
   :undoc-members:
   :show-inheritance:

Event
====================================
.. automodule:: gramps.gen.lib.event
.. autoclass:: Event
   :members:
   :undoc-members:
   :show-inheritance:

Place
====================================
.. automodule:: gramps.gen.lib.place
.. autoclass:: Place
   :members:
   :undoc-members:
   :show-inheritance:

Source
====================================
.. automodule:: gramps.gen.lib.src
.. autoclass:: Source
   :members:
   :undoc-members:
   :show-inheritance:

Citation
====================================
.. automodule:: gramps.gen.lib.citation
.. autoclass:: Citation
   :members:
   :undoc-members:
   :show-inheritance:

Media
====================================
.. automodule:: gramps.gen.lib.media
.. autoclass:: Media
   :members:
   :undoc-members:
   :show-inheritance:

Repository
====================================
.. automodule:: gramps.gen.lib.repo
.. autoclass:: Repository
   :members:
   :undoc-members:
   :show-inheritance:

Note
====================================
.. automodule:: gramps.gen.lib.note
.. autoclass:: Note
   :members:
   :undoc-members:
   :show-inheritance:

*****************************
Secondary objects
*****************************

Secondary Object
====================================
.. automodule:: gramps.gen.lib.secondaryobj
.. autoclass:: SecondaryObject
   :members:
   :undoc-members:
   :show-inheritance:

Address
====================================
.. automodule:: gramps.gen.lib.address
.. autoclass:: Address
   :members:
   :undoc-members:
   :show-inheritance:

Attribute
====================================
.. automodule:: gramps.gen.lib.attribute
.. autoclass:: Attribute
   :members:
   :undoc-members:
   :show-inheritance:

AttributeRoot
====================================
.. autoclass:: AttributeRoot
   :members:
   :undoc-members:
   :show-inheritance:

LdsOrd
====================================
.. automodule:: gramps.gen.lib.ldsord
.. autoclass:: LdsOrd
   :members:
   :undoc-members:
   :show-inheritance:

Location
====================================
.. automodule:: gramps.gen.lib.location
.. autoclass:: Location
   :members:
   :undoc-members:
   :show-inheritance:

Name
====================================
.. automodule:: gramps.gen.lib.name
.. autoclass:: Name
   :members:
   :undoc-members:
   :show-inheritance:

Surname
====================================
.. automodule:: gramps.gen.lib.surname
.. autoclass:: Surname
   :members:
   :undoc-members:
   :show-inheritance:

Url
====================================
.. automodule:: gramps.gen.lib.url
.. autoclass:: Url
   :members:
   :undoc-members:
   :show-inheritance:

*****************************
Reference objects
*****************************

ChildRef
====================================
.. automodule:: gramps.gen.lib.childref
.. autoclass:: ChildRef
   :members:
   :undoc-members:
   :show-inheritance:

EventRef
====================================
.. automodule:: gramps.gen.lib.eventref
.. autoclass:: EventRef
   :members:
   :undoc-members:
   :show-inheritance:

MediaRef
====================================
.. automodule:: gramps.gen.lib.mediaref
.. autoclass:: MediaRef
   :members:
   :undoc-members:
   :show-inheritance:

PersonRef
====================================
.. automodule:: gramps.gen.lib.personref
.. autoclass:: PersonRef
   :members:
   :undoc-members:
   :show-inheritance:

PlaceRef
====================================
.. automodule:: gramps.gen.lib.placeref
.. autoclass:: PlaceRef
   :members:
   :undoc-members:
   :show-inheritance:

RepoRef
====================================
.. automodule:: gramps.gen.lib.reporef
.. autoclass:: RepoRef
   :members:
   :undoc-members:
   :show-inheritance:

*****************************
Table objects
*****************************

Table object
====================================
.. automodule:: gramps.gen.lib.tableobj
   :members:
   :undoc-members:
   :show-inheritance:

Tag
====================================
.. automodule:: gramps.gen.lib.tag
.. autoclass:: Tag
   :members:
   :undoc-members:
   :show-inheritance:

*****************************
Date objects
*****************************
.. automodule:: gramps.gen.lib.date

Date
====================================
.. autoclass:: Date
   :members:
   :undoc-members:
   :show-inheritance:

Span
====================================
.. autoclass:: Span
   :members:
   :undoc-members:
   :show-inheritance:

DateError
====================================
.. autoexception:: DateError

*****************************
Text objects
*****************************

StyledTextTag
===================
.. automodule:: gramps.gen.lib.styledtexttag
.. autoclass:: StyledTextTag
   :members:
   :undoc-members:
   :show-inheritance:

StyledText
===========
.. automodule:: gramps.gen.lib.styledtext
.. autoclass:: StyledText
   :members:
   :undoc-members:
   :show-inheritance:

*****************************
Meta data
*****************************

GenderStats
============

.. automodule:: gramps.gen.lib.genderstats
.. autoclass:: GenderStats
   :members:
   :undoc-members:
   :show-inheritance:

Researcher
===========
.. automodule:: gramps.gen.lib.researcher
.. autoclass:: Researcher
   :members:
   :undoc-members:
   :show-inheritance:

*****************************
Type classes
*****************************
.. automodule:: gramps.gen.lib.grampstype
.. autoclass:: GrampsTypeMeta
   :members:
   :undoc-members:
   :show-inheritance:

GrampsType
===========
.. autoclass:: GrampsType
   :members:
   :undoc-members:
   :show-inheritance:

AttributeType
=============
.. automodule:: gramps.gen.lib.attrtype
   :members:
   :undoc-members:
   :show-inheritance:

ChildRefType
=============
.. automodule:: gramps.gen.lib.childreftype
   :members:
   :undoc-members:
   :show-inheritance:

EventType
===========
.. automodule:: gramps.gen.lib.eventtype
.. autoclass:: EventType
   :members:
   :undoc-members:
   :show-inheritance:

EventRoleType
==============
.. automodule:: gramps.gen.lib.eventroletype
   :members:
   :undoc-members:
   :show-inheritance:

FamilyRelType
=============
.. automodule:: gramps.gen.lib.familyreltype
   :members:
   :undoc-members:
   :show-inheritance:

MarkerType
==========
.. automodule:: gramps.gen.lib.markertype
   :members:
   :undoc-members:
   :show-inheritance:

NameType
===========
.. automodule:: gramps.gen.lib.nametype
   :members:
   :undoc-members:
   :show-inheritance:

NameOriginType
==============
.. automodule:: gramps.gen.lib.nameorigintype
   :members:
   :undoc-members:
   :show-inheritance:

NoteType
=========
.. automodule:: gramps.gen.lib.notetype
   :members:
   :undoc-members:
   :show-inheritance:

PlaceType
=========
.. automodule:: gramps.gen.lib.placetype
   :members:
   :undoc-members:
   :show-inheritance:

RepositoryType
==============
.. automodule:: gramps.gen.lib.repotype
   :members:
   :undoc-members:
   :show-inheritance:

SourceMediaType
================
.. automodule:: gramps.gen.lib.srcmediatype
   :members:
   :undoc-members:
   :show-inheritance:

StyledTextTagType
==================
.. automodule:: gramps.gen.lib.styledtexttagtype
   :members:
   :undoc-members:
   :show-inheritance:

UrlType
========
.. automodule:: gramps.gen.lib.urltype
   :members:
   :undoc-members:
   :show-inheritance:

